#!/usr/bin/perl
#
#  JCapture v1.0 (Mr. Fancy Pants)
#
#  jsl@absynth.com
#  8 November 1999
#  
#  Grabs a webcam image, then does some fancy playing with it.
#
#  tested with:  
#      Connectix Color QuickCam & CQCam v0.90p7
#      ImageMagick/convert v4.2.9
#  on a RedHat 6.1 p-75 box
#
# 2000 Jan 11:  modified to put the files in /cam/temp/ then copy them 

#############
# paths to executables:

$convert_path = "/usr/X11R6/bin/convert";

$link_url  = "http://www.cis.rit.edu/~sdlpci";
$link_name = "Jerry's Homepage";
$link_nick = "(AKA BleuLlama, Jerronimo, Scott)";
$page_credit =<<EOB;
    Created with: Connectix Color QuickCam, CQCam v0.90p7, 
    ImageMagick/convert v4.2.9, JCapture v1.0
EOB

# NOTE:  this script assumes that the image will be going into /cam  make
#        sure the directory exists, or change the path below.


# _SRC_        source filename
# _DEST_       source filename
# _RND_P_      1-100
# _RND_Q_      3-8
# _RGB_        "red", "green" or "blue"
# _RND_GEO_    random geometry  0x0+W+H
# _RND_ANG_    random angles    DxY
# _NOISE_      one of @noises

@rgb = ("red", "green", "blue");

@noises = ("Gaussian", "Multiplicative", "Impulse", "Laplacian", "Poisson");

@mods = (
    "/bin/cp _SRC_ _DEST_",
    "$convert_path -charcoal _RND_P_ _SRC_ _DEST_",
    "$convert_path -contrast -contrast -contrast -contrast -contrast -contrast _SRC_ _DEST_",
    "$convert_path +contrast +contrast +contrast +contrast +contrast +contrast _SRC_ _DEST_",
    "$convert_path -despeckle _SRC_ _DEST_",
    "$convert_path -monochrome _SRC_ _DEST_",
    "$convert_path -flop _SRC_ _DEST_",
    "$convert_path -edge _RND_Q_ _SRC_ _DEST_",
    "$convert_path -sharpen _RND_P_ _SRC_ _DEST_",
    "$convert_path -emboss _SRC_ _DEST_",
    "$convert_path -implode _RND_P_ _SRC_ _DEST_",
    "$convert_path -implode -_RND_P_ _SRC_ _DEST_",
    "$convert_path -modulate 0,_RND_P_,0 _SRC_ _DEST_",
    "$convert_path -modulate 0,0,_RND_P_ _SRC_ _DEST_",
    "$convert_path -negate _SRC_ _DEST_",
    "$convert_path +noise _NOISE_ _SRC_ _DEST_",
    "$convert_path -paint _RND_Q_ _SRC_ _DEST_",
    "$convert_path -roll _RND_GEO_ _SRC_ _DEST_",
    "$convert_path -segment _RND_Q_ _SRC_ _DEST_",
    "$convert_path -solarize _RND_P_ _SRC_ _DEST_",
    "$convert_path -spread _RND_Q_ _SRC_ _DEST_",
    "$convert_path -swirl _RND_P_ _SRC_ _DEST_",

    # these are annoying, do little, not much, or they take too long...
    #"$convert_path -blur _RND_P_ _SRC_ _DEST_",
    #"$convert_path -flip _SRC_ _DEST_",
    #"$convert_path -antialias _SRC_ _DEST_",
    #"$convert_path +noise uniform _SRC_ _DEST_",
    #"$convert_path -shear _RND_ANG_ _SRC_ _DEST_",
    #"$convert_path -wave _RND_ANG_ _SRC_ _DEST_",
    #"$convert_path -equalize _SRC_ _DEST_",
    #"$convert_path -enhance _SRC_ _DEST_",
    #"$convert_path -colorize _RND_RGB_ _SRC_ _DEST_",
    #"$convert_path -layer _RGB_ _SRC_ _DEST_",
    #"$convert_path -modulate _RND_P_,0,0 _SRC_ _DEST_",
);



# generate a simple refreshing html index page.
#  make_html("destination.html");
sub make_html
{
    $fname = shift;
    $date = `/bin/date 2>&1`;
    open CMF, ">$fname";
    $sels = join "<br>", @used_filters;
    printf CMF<<EOB;
	<html><head>
	<META HTTP-EQUIV="refresh" content="60">
	<title>Jerronicam</title>
	</head>
	<body bgcolor="black" text="black" link="orange" vlink="red" alink="red">
	<br><center>
	<img border=0 src="current.jpg">
	<img border=0 src="new.jpg">
	<br clear=all>
	<font color="red">$date</font>
	<br>
	<font color = "orange">
	    <a href="$link_url">$link_name</a>
	    <br>$link_nick
	</font> <br>
	$sels
	<br> <font color="#444444">
	    $page_credit
	</font><br>
	</body>
	</html>
EOB
    close CMF;
}

# do something random and interesting to the image.
#  mogrify ("/source/path/name", "/destination/path/name");
sub mogrify
{
    $src = shift;
    $dest = shift;

    # choose a filter
    $fno = int rand (scalar @mods);
    $sel = $mods[ $fno ];

    # replace the variables
    $sel =~ s/_SRC_/$src/g;
    $sel =~ s/_DEST_/$dest/g;

#    printf "$fno $sel\n";

    # _SRC_        source filename
    # _DEST_       source filename
    # _RND_P_      1-100
    # _RND_Q_      3-8
    # _RGB_        "red", "green" or "blue"
    # _RND_GEO_    random geometry  WxH

    $r = int rand(100); $g=int rand(100); $b=int rand(100);
	$sel =~ s/_RND_RGB_/$r\/$g\/$b/;
    $t = int rand(100); $sel =~ s/_RND_P_/$t/;
    $t = 3+int rand(5); $sel =~ s/_RND_Q_/$t/;
    #$t = int rand(3); $sel =~ s/_RGB_/"$rgb[$t]"/;
    $t = int rand(scalar @noises); $sel =~ s/_NOISE_/"$noises[$t]"/;

    $t = sprintf "0x0+%d+%d",int rand(320),int rand(240);  
	$sel =~ s/_RND_GEO_/$t/;
#    $t = sprintf "%dx%d",int rand(360),int rand(360);  
#	$sel =~ s/_RND_ANG_/$t/;

    #process the image
    $junk = `$sel 2>&1`;

    $sel =~ s/^\/bin\///g;
    $sel =~ s/^\/usr\/X11R6\/bin\///g;
    $sel =~ s/\/cam\///g;

    push @used_filters, $sel;
}


# call the image capture program.. if you have a different one, put it in here.
#  capture("/dest/file/name.jpg");
sub capture
{
    local $capfile = shift;

    $junk = `/usr/local/bin/cqcam -j > $capfile 2>&1`;
    chmod 0644, "$capfile";
}


# call all of the subsections...
sub main
{
    #capture the image
    capture("/cam/temp/new.jpg");

    $nfilters = 1+int rand(2);

    $src_f = sprintf "/cam/temp/new.jpg", $i; 
    for ($i = 0 ; $i < $nfilters ; $i++)
    {
	$dest_f = sprintf "/cam/temp/%d.jpg", $i; 
	mogrify($src_f, $dest_f);
	$src_f = $dest_f;
    }
    make_html("/cam/index.html");

    system "cp $src_f /cam/current.jpg";
    system "cp /cam/temp/new.jpg /cam/";
}

&main;
